package org.apache.commons.lang3.function;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Objects;

@FunctionalInterface
public interface FailableFunction<T, R, E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailableFunction NOP = t -> null;
  
  static <T, E extends Throwable> org.apache.commons.lang3.function.FailableFunction<T, T, E> identity() {
    return t -> t;
  }
  
  static <T, R, E extends Throwable> org.apache.commons.lang3.function.FailableFunction<T, R, E> nop() {
    return NOP;
  }
  
  default <V> org.apache.commons.lang3.function.FailableFunction<T, V, E> andThen(org.apache.commons.lang3.function.FailableFunction<? super R, ? extends V, E> after) {
    Objects.requireNonNull(after);
    return t -> after.apply(apply((T)t));
  }
  
  default <V> org.apache.commons.lang3.function.FailableFunction<V, R, E> compose(org.apache.commons.lang3.function.FailableFunction<? super V, ? extends T, E> before) {
    Objects.requireNonNull(before);
    return v -> apply((T)before.apply(v));
  }
  
  R apply(T paramT) throws E;
}
